<?php
class ControllerPaymenteasypay extends Controller {
	protected function index() {
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
		$this->data['redirect'] = $this->url->link('payment/easypay/ep_redirect');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['cancel_return'] = $this->url->link('checkout/payment');
		} else {
			$this->data['cancel_return'] = $this->url->link('checkout/guest_step_2');
		}
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['back'] = $this->url->link('checkout/payment');
		} else {
			$this->data['back'] = $this->url->link('checkout/guest_step_2');
		}
		
		$this->id = 'payment';
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/easypay.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/easypay.tpl';
		} else {
			$this->template = 'default/template/payment/easypay.tpl';
		}
		$this->render();
	}
	
	//Ошибка оплаты
	public function fail() {
		$this->cart->clear();//Очищение корзины

		//Изменение статуса в случае ошибки
		$this->load->model('checkout/order');
		$this->model_checkout_order->update($this->session->data['order_id'], $this->config->get('cancel_status_id'));

		$this->redirect($this->url->link('checkout/checkout'));
		
		return TRUE;
	}

	# перенаправление клиента после оплаты
	public function success() {

		$this->redirect($this->url->link('checkout/success'));
		
		return TRUE;		
	}

	#уведомление об оплате
	public function notify() {
		$order_mer_code = (int)$this->request->post['order_mer_code'];
		$sum            = $this->request->post['sum'];
		$mer_no         = $this->request->post['mer_no'];
		$card           = $this->request->post['card'];
		$purch_date     = $this->request->post['purch_date'];
		$web_key        = $this->config->get('webkey');
		$notify_sig     = $this->request->post['notify_signature'];
		
		$sig = md5 ($order_mer_code . $sum . $mer_no . $card . $purch_date . $web_key);

		//Проверка электронной подписи
		if ($sig == $notify_sig){
			header("HTTP/1.0 200 OK");
			print $status = 'OK | the notice is processed';
			$this->load->model('checkout/order');
			$this->model_checkout_order->update($order_mer_code, $this->config->get('processing_status_id'));
		} else {
			header("HTTP/1.0 400 Bad Request");
			print $status = 'FAILED | incorrect digital signature';
		}
	}
	//Перенаправление на страницу /weborder/
	public function ep_redirect() {

		$this->data['action'] = 'https://ssl.easypay.by/weborder/';
		$this->data['merchant']    = $this->config->get('merchant');  
		$this->data['order_id']    = $this->session->data['order_id'];
		$this->data['EP_OrderInfo'] = "Заказ №".$this->data['order_id'];

		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$this->data['debug']       = $this->config->get('debug');
		$this->data['expires']     = $this->config->get('expires');
		$this->data['hash']        = md5($this->config->get('merchant') . $this->config->get('webkey') . $this->session->data['order_id'] . $order_info['total']);
		
		$this->data['EP_Comment'] = "Заказ от магазина ".$order_info['store_name'];
		$this->data['amount'] = $order_info['total'];
		$this->data['return'] = $this->url->link('payment/easypay/success');
		$this->data['fail']   = $this->url->link('payment/easypay/fail');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/easypay_redirect.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/easypay_redirect.tpl';
		} else {
			$this->template = 'default/template/payment/easypay_redirect.tpl';
		}
		

		$this->model_checkout_order->confirm($this->data['order_id'], $this->config->get('pending_status_id'));
		$this->response->setOutput($this->render());
	}

}

?>